VERSION 5.00
Begin VB.UserControl FlexProgressBar 
   ClientHeight    =   1320
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3840
   FillColor       =   &H8000000F&
   ForeColor       =   &H8000000F&
   ScaleHeight     =   1320
   ScaleWidth      =   3840
   ToolboxBitmap   =   "FlexProgressBar.ctx":0000
   Begin VB.PictureBox picPBar 
      ClipControls    =   0   'False
      FillColor       =   &H8000000F&
      ForeColor       =   &H00C00000&
      Height          =   348
      Left            =   384
      ScaleHeight     =   300
      ScaleWidth      =   2652
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   384
      Width           =   2700
   End
End
Attribute VB_Name = "FlexProgressBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Developed by Ted Schopenhouer   ted.schopenhouer@12Move.nl

'This sources may be used freely without the intention of commercial distribution.
'For ALL other use of this control YOU MUST HAVE PERMISSION of the developer.


'Default Property Values:
Const m_def_PartitionStep = 250
Const m_def_Partition = True

Const m_def_Min = 0
Const m_def_Max = 100

'Property Variables:
Dim m_PartitionStep As Single
Dim m_Partition As Boolean

Dim m_Min As Double
Dim m_Max As Double

Private lTotalPercent As Double
Private lWidthPercent As Double

Enum enumAppearance
   Flat = 0
   [3 D] = 1
End Enum

Enum enumBorderStyle
   None = 0
   [Fixed Single] = 1
End Enum

Event Percent(Percent As Double)

Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
lTotalPercent = 1 / ((m_Max - m_Min) * 0.01)
lWidthPercent = picPBar.Width * 0.01
End Sub

Public Property Get Min() As Double
Min = m_Min
End Property

Public Property Let Min(ByVal New_Min As Double)

If New_Min >= m_Max Then Err.Raise 380, , "Min MUST be LESS then Max"

m_Min = New_Min

Call Refresh

PropertyChanged "Min"

End Property

Public Property Get Max() As Double
Max = m_Max
End Property

Public Property Let Max(ByVal New_Max As Double)

If New_Max <= m_Min Then Err.Raise 380, , "Max MUST be GREATER then Min"

m_Max = New_Max
Call Refresh
PropertyChanged "Max"

End Property

Public Sub Clear()
picPBar.Line (0, 0)-(picPBar.Width, picPBar.Height), picPBar.BackColor, BF
End Sub

Public Property Let Value(ByVal New_Value As Double)
Dim dW            As Double      'Double wIDTH
Dim dP            As Double      'Double pERCENT
Dim siC           As Single      'siNGLE cOUNTER
Dim mHeight       As Single      'Memory (picPBar) hEIGHT
Dim mBackColor    As OLE_COLOR   'Memory bACKcOLOR

New_Value = New_Value - m_Min

dP = New_Value * lTotalPercent

RaiseEvent Percent(dP)

dW = dP * lWidthPercent

mHeight = picPBar.Height
mBackColor = picPBar.BackColor

picPBar.Line (0, 0)-(dW, mHeight), , BF

If Partition Then

   For siC = PartitionStep To dW Step PartitionStep
      
      picPBar.Line (siC, 0)-(siC, mHeight), mBackColor, BF
   
   Next
   
End If

picPBar.Line (dW, 0)-(picPBar.Width, mHeight), mBackColor, BF

End Property


'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
m_Min = m_def_Min
m_Max = m_def_Max
m_Partition = m_def_Partition
m_PartitionStep = m_def_PartitionStep
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
picPBar.BorderStyle = PropBag.ReadProperty("BorderStyle", enumBorderStyle.[Fixed Single])
picPBar.Appearance = PropBag.ReadProperty("Appearance", enumAppearance.[3 D])
m_Min = PropBag.ReadProperty("Min", m_def_Min)
m_Max = PropBag.ReadProperty("Max", m_def_Max)
picPBar.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
picPBar.ForeColor = PropBag.ReadProperty("ForeColor", &HFF0000)
picPBar.Enabled = PropBag.ReadProperty("Enabled", True)
m_Partition = PropBag.ReadProperty("Partition", m_def_Partition)
m_PartitionStep = PropBag.ReadProperty("PartitionStep", m_def_PartitionStep)
End Sub

Private Sub UserControl_Resize()
picPBar.Move 0, 0, ScaleWidth, ScaleHeight
Refresh
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
Call PropBag.WriteProperty("BorderStyle", picPBar.BorderStyle, enumBorderStyle.[Fixed Single])
Call PropBag.WriteProperty("Appearance", picPBar.Appearance, enumAppearance.[3 D])
Call PropBag.WriteProperty("Min", m_Min, m_def_Min)
Call PropBag.WriteProperty("Max", m_Max, m_def_Max)
Call PropBag.WriteProperty("BackColor", picPBar.BackColor, &H8000000F)
Call PropBag.WriteProperty("ForeColor", picPBar.ForeColor, &HFF0000)
Call PropBag.WriteProperty("Enabled", picPBar.Enabled, True)
Call PropBag.WriteProperty("Partition", m_Partition, m_def_Partition)
Call PropBag.WriteProperty("PartitionStep", m_PartitionStep, m_def_PartitionStep)
End Sub


Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
BackColor = picPBar.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
picPBar.BackColor() = New_BackColor
PropertyChanged "BackColor"
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
ForeColor = picPBar.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
picPBar.ForeColor() = New_ForeColor
PropertyChanged "ForeColor"
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Enabled = picPBar.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
picPBar.Enabled() = New_Enabled
PropertyChanged "Enabled"
End Property

Public Property Get BorderStyle() As enumBorderStyle
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
BorderStyle = picPBar.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As enumBorderStyle)
picPBar.BorderStyle() = New_BorderStyle
PropertyChanged "BorderStyle"
End Property

Public Property Get Appearance() As enumAppearance
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
Appearance = picPBar.Appearance
End Property

Public Property Let Appearance(ByVal New_Appearance As enumAppearance)
picPBar.Appearance() = New_Appearance
PropertyChanged "Appearance"
End Property

Public Property Get Partition() As Boolean
Partition = m_Partition
End Property

Public Property Let Partition(ByVal New_Partition As Boolean)
m_Partition = New_Partition
PropertyChanged "Partition"
End Property

Public Property Get PartitionStep() As Single
PartitionStep = m_PartitionStep
End Property

Public Property Let PartitionStep(ByVal New_PartitionStep As Single)
m_PartitionStep = New_PartitionStep
PropertyChanged "PartitionStep"
End Property

Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns a handle (from Microsoft Windows) to an object's window."
hWnd = UserControl.hWnd
End Property

